/**
 * XIBLS接口定义
 */
;
(function () {

    var XIBLS = XIBLS || {},
        _XIBLS = {
            Version: "1.1.0",
            Author: "Aaron Wu(wujp@xib.com.cn)",
            Lisence: "XIB"
        };
    window.XIBLS = $.extend(XIBLS, _XIBLS);

    XIBLS.outsideUrl = {
        webBank: '/webbank/',
        WECHAT_MAIN_MENU: '/mbank/webank/T_Z_LOGIN_WAP.html?flowsn=2110',
        WECHAT_LOGIN: 'https://open.weixin.qq.com/connect/oauth2/authorize?appid=wxffea89ae59c544c9&redirect_uri=https%3A%2F%2Fmobile.xib.com.cn%2Fmbank%2Fwebank%2FT_Z_LOGIN_WAP.html&response_type=code&scope=snsapi_base&state=4C254AB9092C638829DB9C9D52961D44#wechat_redirect'
    };

    function connectWebView() {
        var ua = navigator.userAgent;
        XIBLS.mbank = ua.toLowerCase().indexOf('xibmbank') != -1; //手机银行客户端
        XIBLS.clientVersion = ua.toLowerCase().slice(ua.toLowerCase().indexOf('xibmbank/') + 'xibmbank/'.length, ua.length) || "1.0.0"; //手机银行H5框架版本
        XIBLS.clientVersion = XIBLS.clientVersion.slice(0, XIBLS.clientVersion.indexOf(';'));
        XIBLS.ios = ua.toLowerCase().indexOf('applewebkit') != -1;
        XIBLS.android = ua.toLowerCase().indexOf('android') != -1;
        XIBLS.webchat = ua.toLowerCase().indexOf('micromessenger') != -1;
        XIBLS.browserVersion = parseFloat(ua.slice(ua.indexOf('AppleWebKit/') + 'AppleWebKit/'.length, ua.indexOf('(KHTML')));
        XIBLS.webBank = !XIBLS.mbank && (window.sessionStorage?window.sessionStorage.getItem('webType')==='web':false);
    }

    /*function connectWebViewJavascriptBridge(callback) {
        if (window.WebViewJavascriptBridge) {
            callback(WebViewJavascriptBridge);
        } else {

            document.addEventListener('WebViewJavascriptBridgeReady', function () {
                callback(WebViewJavascriptBridge);
            }, false);
        }
    }

    connectWebViewJavascriptBridge(function (bridge) {
        bridge.init(function (message, responseCallback) {});
    });*/

    //plugin
    XIBLS.saveData = function (dataPair, onSuccess, onFail) {
        dataPair = dataPair || {};
        var key = dataPair.key || '';
        var value = dataPair.value || '';
        //alert("key:value" + key + value);
        if (XIBLS.mbank) {
            cordova.exec(onSuccess, onFail, 'CommonTools', 'saveData', [key, value]);
        }
    };

    XIBLS.getData = function (key, onSuccess, onFail) {
        key = key || '';
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'CommonTools', 'getData', {'key':key});
    };

    XIBLS.openUri = function (type, uri, args, onSuccess, onFail) {
        var options  = {
        		type: type || '',
                uri: uri || '',
                args: args || {}
            };
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'CommonTools', 'openUri', options);
    };

    //交易密码键盘
    XIBLS.showTradeKeyboard = function (target, onSuccess, onFail,options) {
        var top = target.getClientRects()[0]["top"];
        var bottom = target.getClientRects()[0]["bottom"];
        var btnHeight = target.getClientRects()[0]["height"];
        var scrollTop = document.body.scrollTop;
        var currentYPos = bottom;
        var contentHight = document.body.scrollHeight;
				options = options || {};
        //alert('top'+top+" btnHeight"+btnHeight +" bottom"+bottom +" scrollTop"+scrollTop);
        //[inputId,inputType,max,currentYPos]
        var kbOptions  = {
            inputId: target.id || 'default',
            cleanFlag: options.cleanFlag || '0',
            inputType: '1',
            maxLength: '6',
            currentYPos: currentYPos,
            contentHight: contentHight
        };
//        XIBLS.showSafeKeyboard(options, onSuccess, onFail);
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'KeyboardPlugin', 'showSafeKeyboard', kbOptions);
    };


    //登录密码键盘
    XIBLS.showLoginKeyboard = function (target, onSuccess, onFail,options) {
        var bottom = target.getClientRects()[0]["bottom"];
        var top = target.getClientRects()[0]["top"];
        var btnHeight = target.getClientRects()[0]["height"];
        var currentYPos = bottom;
        var contentHight = document.body.scrollHeight;
				options = options || {};
        //[inputId,inputType,max,currentYPos]
        var kbOptions = {
            inputId: target.id || 'default',
            cleanFlag: options.cleanFlag || '0',
            inputType: '0',
            maxLength: '12',
            currentYPos: currentYPos,
            contentHight: contentHight
        };
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'KeyboardPlugin', 'showSafeKeyboard', kbOptions);
    };

    XIBLS.showSafeKeyboard = function (options, onSuccess, onFail) {

        var inputType = options.inputType || '0';
        var cleanFlag = options.cleanFlag || '0';
        var maxLength = options.maxLength || '16';
        var inputId = options.inputId || 'default';
        var currentYPos = options.currentYPos || '0';
        var contentHight = options.contentHight;
        //  alert([inputId,inputType,max,currentYPos]);


        WebViewJavascriptBridge.callService(onSuccess, onFail, 'KeyboardPlugin', 'showSafeKeyboard', {
            inputId: inputId,
            cleanFlag:cleanFlag,
            inputType: inputType,
            maxLength: maxLength,
            currentYPos: currentYPos,
            contentHight: contentHight
        });
    };

    /**
     * 关闭密码键盘
     */
    XIBLS.hideSafeKeyboard = function (onSuccess, onFail) {
        //alert('hideSafeKeyboard');
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'KeyboardPlugin', 'hideSafeKeyboard', {});
    };

    /**
     * 获取加密字符串
     var options = options = {
     ids:['passbtn'],
     encrytetype:'0'   // 密码类型 0 登录密码: 1 交易密码
     };
     */
    XIBLS.obtainEncrypteStr = function (options, onSuccess, onFail) {
        var ids = options.ids || ['default'];
        var encrytetype = options.encrytetype || '1';
        var rsaPub = options.rsaPub || '';
        var random = options.random || '';
        //alert([ids,encrytetype]);
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'KeyboardPlugin', 'obtainEncrypteStr', {
                'ids': ids,
                'encrytetype' : encrytetype,
                'rsaPub' : rsaPub,
                'random' : random
            });
    };

    /**
       * 比较输入是否相符 true or false
       var options = options = {
       ids:['passbtn'],
       };
       */
    XIBLS.compareIfEqual = function (options, onSuccess, onFail) {
        var ids = options.ids || ['default', 'default'];
         WebViewJavascriptBridge.callService(onSuccess, onFail, 'KeyboardPlugin', 'compareIfEqual', {'ids': ids});
    };

    /**
     * 登录
     *  @param webCallBack :true 登录后执行回调，false 登录后客户端默认进入首页
     *  @param {Function} onSuccess回调参数: result '1' 登录成功 '0' 取消登录
     *      return param 无
     *  @param {Function} onFail回调参数:
     *      return param 无
     */
    XIBLS.login = function (webCallBack, onSuccess, onFail, options) {
        if(XIBLS.webBank){
            window.location.href = XIBLS.outsideUrl.webBank + '#/logon/index';
            return;
        } else if(XIBLS.webchat){
        	window.location.href = XIBLS.outsideUrl.WECHAT_LOGIN;
            return;
        }
        var flag = webCallBack ? '1' : '0';
        options = options || {};
        var callbackUrl = options.callbackUrl || '';
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'NavigatePlugin', 'navigate', {
            target: 'login',
            param: {
                'callBack': flag,
                'callbackUrl': callbackUrl
            }
        });
    };


    /**
     * 登录关闭当前网页窗口
     * */
 	XIBLS.closeWindow = function () {
 		if(XIBLS.mbank){
 			WebViewJavascriptBridge.callService(null, null,'NavigatePlugin', 'navigate', {target: 'close'});
 		}else if(XIBLS.webchat){
 			if(window.location.href.indexOf('T_Z_LOGIN_WAP') >= 0 || window.location.href.indexOf('T_WXBD') >= 0 ){
        		WeixinJSBridge.call('closeWindow');
        		return;
        	}else {
        		window.location.href=XIBLS.outsideUrl.WECHAT_MAIN_MENU;
        	}
    	} else {
    		window.close();
    	}
    };


    /**
     * 重置App （清除状态重新进入应用）
     * */
 	XIBLS.restart = function () {
    	WebViewJavascriptBridge.callService(null, null,'NavigatePlugin', 'navigate', {target: 'restart'});
    };

	/**
	 * 显示通讯框,根据业务场景需要是否让当前界面其它按钮不可以被点击<br/>
	 * @param message  空或null则显示默认通讯提示
	 * @param disableView true/false 默认为true
	 */
    XIBLS.showProgressDialog = function (message, disableView) {
    	var msg = message || '';
    	var disable = true;
    	if(arguments.length >= 2) {
    		disable = disableView;
    	}

    	WebViewJavascriptBridge.callService(null, null,'CommonTools', 'showProgressDialog', {'msg':msg, 'disableView':disable});
    };

    /**
	 * 隐藏通讯框
	 */
    XIBLS.hideProgressDialog = function () {
    	WebViewJavascriptBridge.callService(null, null,'CommonTools', 'hideProgressDialog', {});
    };

    /**
     * Toast 显示
     * @param message 要toast的内容
     * @param showMode toast显示类型，1 短显示2秒， 0 长显示3秒，默认使用短时间显示2秒
     */
    XIBLS.toast = function (message, showMode) {
    	var mode = showMode || '1';
    	WebViewJavascriptBridge.callService(null, null,'CommonTools', 'toast',{'msg':message, 'mode':mode});
    };

    /**
     * 显示Dialog
     * @param options={
     * 'btnType':'all',//yes/no/all 允许为空默认all
     * 'title':'', //对话框标题，允许为空
     * 'message':'对话框显示信息'//对话框显示信息，不允许为空
     * }
     */
    XIBLS.showDialog = function (options, onSuccess, onFail) {
    	var btnType = options.btnType || "all";
    	var title = options.title || "";
    	var message = options.message || "";
    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'CommonTools', 'showDialog', {'btnType':btnType, 'title':title, 'message':message});
    };


    XIBLS.chooseContact = function(onSuccess,onFail){
    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'Contact', 'chooseContact', {});
    };


    XIBLS.scanQRCode = function(options,onSuccess,onFail){
    	var needDecode = options.needDecode || '1';
    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'Scan', 'scanQRCode', {needDecode:needDecode});
    };


    XIBLS.genQRCode = function(options,onSuccess,onFail){
    	var code = options.code || '';
        var needEncode = options.needEncode || '1';
    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'Scan', 'genQRCode', {code:code,needEncode:needEncode});
    };

    XIBLS.saveBase64PNG = function(options,onSuccess,onFail){
    	var pngData = options.pngData || '';
    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'Scan', 'saveBase64PNG', {pngData:pngData});
    };

    /**
     *
     * @param options
     * {
     *   code: '要生成的二维码的数据',
     *   needEncode: '1',  //1需要解码，0不需要解码，默认0
     *   genBarCode: '1' //1需要生成条形码，0不生成条形码，默认0
	 *   showLogo: '1'  //1显示二维码中间logo，0不显示，默认0
	 *   showCode: '0'  //1条型码下方显示code，0不显示，默认0
     * }
     * @param onSuccess
     * {
     *   qrCode: '二维码base64数据',
     *  barCode: '条形码base64数据'//根据genBarCode参数来决定是否有该字段
     * }
     * @param onFail
     */
    XIBLS.genQRPNG = function(options,onSuccess,onFail){
      var code = options.code || '';
      var needEncode = options.needEncode || '0';
      var genBarCode = options.genBarCode || '0';
      var showLogo = options.showLogo || '0';
      var showCode = options.showCode || '0';
      WebViewJavascriptBridge.callService(onSuccess, onFail, 'QRScan', 'genQRPNG', {'code':code,'needEncode':needEncode,'genBarCode':genBarCode,'showLogo':showLogo,'showCode':showCode});
    };

    XIBLS.saveQRPNG = function(options,onSuccess,onFail){
      var pngData = options.pngData || '';
      WebViewJavascriptBridge.callService(onSuccess, onFail, 'QRScan', 'saveQRPNG', {pngData:pngData});
    };

    //扫描出的结果放到result中
    XIBLS.scanQRPNG = function(options,onSuccess,onFail){
      var needDecode = options.needDecode || '1';
      WebViewJavascriptBridge.callService(onSuccess, onFail, 'QRScan', 'scanQRPNG', {needDecode:needDecode});
    };

	XIBLS.Brightness = {};
    //设置为最大屏幕亮度
    XIBLS.Brightness.setMax = function (onSuccess, onFail) {
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'Brightness', 'setMax', {});
    };

    //还原屏幕亮度
    XIBLS.Brightness.restore = function (onSuccess, onFail) {
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'Brightness', 'restore', {});
    };


    XIBLS.bindBar = function (bar, onSuccess, onFail) {
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'UIControlPlugin', 'bindBar', bar);
    };

    //定位
     XIBLS.getLocation = function (onSuccess, onFail) {
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'CommonTools', 'userLocation', {});
    };

    XIBLS.Event = {};
    XIBLS.Event.support = function () {
        return XIBLS.mbank && (parseFloat(XIBLS.clientVersion) >= 1.0);
    };

    //添加事件监听
    XIBLS.Event.on = function (event, callBack) {
        WebViewJavascriptBridge.onEvent(event, callBack);
    };

    //移除事件监听
    XIBLS.Event.off = function (event, callBack) {
        WebViewJavascriptBridge.offEvent(event, callBack);
    };

    //触发事件
    XIBLS.Event.trigger = function (event, data) {//客户端实现该方法, bridge方法需调整，最终调用messagehandle，
        WebViewJavascriptBridge.callService(null, null, 'Event', 'trigger', {
            event: event,
            data: data
        });
    };

		XIBLS.OCR = {};
    XIBLS.OCR.support = function () {
        return XIBLS.mbank && (parseFloat(XIBLS.clientVersion) >= 1.1);
    };

     //获取缓存的图片
     XIBLS.OCR.getIdcardData = function (options, onSuccess, onFail) {
         options = options || {};
         WebViewJavascriptBridge.callService(onSuccess, onFail, 'OCR', 'getIdcardPic', options);
         /***
         onSuccess(pics){
             front:'base64',
             back:'base64',
             cust:'base64',
			 ocrdata:{"name":"厦门国际", "sex":"男", "folk":"民族", "birthday":"出生日期", "address":"地址", "idNum":"证件号码", "issue":"签发机关", "period":"有效日期","head":"base64"}
         }***/

     };
    //清理缓存，在注册开始和结束时调用
    XIBLS.OCR.idcardReset = function (onSuccess, onFail) {
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'OCR', 'idcardReset', {});
    };

    //上传服务端，传入token，服务端判断token，服务端缓存token和文件列表的关联
    XIBLS.OCR.postOcrToHost = function (options, onSuccess, onFail) {
        //options.token
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'OCR', 'idcardPost', options);
    };

	/***
      *onSuccess(ocr){
      *     ocrdata:{"name":"厦门国际", "sex":"男", "folk":"民族", "birthday":"出生日期", "address":"地址", "idNum":"证件号码", "head":"base64"},
			*		  tempImage:"base64"
      * }
      ***/
    XIBLS.OCR.idcardFront = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'OCR', 'idcardFront', options);
    };

	/***
      *  onSuccess(ocr){
      *      ocrdata:{"issue":"签发机关", "period":"有效日期"},
			*		   tempImage:"base64"
      *  }
      **/
    XIBLS.OCR.idcardBack = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'OCR', 'idcardBack', options);
    };

	   /***
      *  onSuccess(ocr){
      *      ocrData:{},
	    *		   tempImage:"base64"
      *  }
      **/
    XIBLS.OCR.idcardCustPhoto = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'OCR', 'idcardCustPhoto', options);

    };

    var BaseItem = {
        itemType: "function",
        id: "default",
        icon: "back.png",
        title: "default",
        useMode: "0",
        onSuccess: null,
        onFail: null,
        onTrigger: null
    };

    BaseItem.trigger = function (id) {
        if ("function" === typeof this.onTrigger)
            this.onTrigger.apply(id);
    };
    BaseItem.successCallback = function (result) {
        if ("function" === typeof this.onSuccess)
            this.onSuccess.apply(null, [result]);
    };
    BaseItem.failCallback = function (result) {
        if ("function" === typeof this.onFail)
            this.onFail.apply(null, [result]);
    };

    var LeftBar = $.extend({}, BaseItem);
    LeftBar.id = "leftBar";
    LeftBar.icon = "bar_back.png";
    LeftBar.useMode = "1";
    var RightBar = $.extend({}, BaseItem);
    RightBar.id = "rightBar";
    RightBar.icon = "bar_more.png";
    var TitleBar = $.extend({}, BaseItem);
    TitleBar.id = "titleBar";
    TitleBar.icon = "";

    XIBLS.Bar = {
        leftBar: {},
        titleBar: {},
        rightBar: {}
    };

    XIBLS.Bar.bind = function () {
        var left = XIBLS.Bar.leftBar || {};
        var right = XIBLS.Bar.rightBar || {};
        var title = XIBLS.Bar.titleBar || {};

        var a = $.extend({}, {
            id: "leftbar",
            icon: "bar_back.png",
            keepAlive: "0",
        }, left, {
            useMode: "function" === typeof left.onTrigger ? "1" : "0"
        });

        var b = $.extend({}, {
            id: "titleBar",
            title: document.title
        }, title, {});

        var c = $.extend({}, {
            id: "rightBar",
            icon: "bar_more.png",
            keepAlive: "1",
        }, right, {
            useMode: "function" === typeof right.onTrigger ? "1" : "0"
        });

        if (!XIBLS.mbank) {
            var hhead = document.createElement("div");
            if (XIBLS.webBank) {
                hhead.className = "xm-header-wrapper";
                var left = "<div class='mint-header-button is-left'>" +
                    (a.useMode === "1" ? "<a href='javascript:void(0);' onclick='javascript:XIBLS.Bar.leftBar.onTrigger()'>" :
                    "<a href='" + XIBLS.outsideUrl.webBank + "#/menu/main'>") +
                    "<img src='/mbank/config/icons/" + a.icon +"' width='30' style='display: inline-block;'></a></div>";
                var right = "<div class='mint-header-button is-right'><a href='javascript:void(0);' " +
                    (c.useMode === "1" ? "onclick='javascript:XIBLS.Bar.rightBar.onTrigger()'><img src='/mbank/config/icons/" + c.icon +"' width='30'></a>" : "></a>") +
                    "</div>";
                var title = "<h1 class='mint-header-title'>" + b.title + "</h1>";
                hhead.innerHTML = "<div class='mint-header'>" + left + title + right + "</div>";
            }  else if (XIBLS.webchat) {
            	hhead.className = "xm-header-wrapper";
                var left = a.useMode === "1" ? "<div class='nav-left' id='leftBar' onclick='javascript:XIBLS.Bar.leftBar.onTrigger()'></div>"
                		: window.sessionStorage.getItem('webType')==='wechat' ? "<div class='nav-left' id='leftBar' onclick='javascript:XIBLS.closeWindow()'></div>":
                			"";
                var right = c.useMode === "1" ? "<div class='nav-right' id='rightBar' onclick='javascript:XIBLS.Bar.rightBar.onTrigger()'></div>" : "";
                var title = "<div class='nav-title'>" + b.title + "</div>";
                hhead.innerHTML = left + title + right;

                pushHistory();
                var bool=false;
                setTimeout(function(){
                    bool=true;
                },1000);
                window.addEventListener("popstate", function(e) {
                    if(bool){
                        if(a.useMode === "1"){
                        	XIBLS.Bar.leftBar.onTrigger();
                        }else if(window.sessionStorage.getItem('webType')==='wechat') {
                        	XIBLS.closeWindow();
                        } else {
                        	WeixinJSBridge.call('closeWindow');
                        }
                    }
                }, false);

            } else {
               // hhead.className = "xm-header-wrapper";
               // var left = a.useMode === "1" ? "<div class='nav-left' id='leftBar' onclick='javascript:XIBLS.Bar.leftBar.onTrigger()'></div>" : "";
               // var right = c.useMode === "1" ? "<div class='nav-right' id='rightBar' onclick='javascript:XIBLS.Bar.rightBar.onTrigger()'></div>" : "";
               // var title = "<div class='nav-title'>" + b.title + "</div>";
               // hhead.innerHTML = left + title + right;
            }
            document.body.appendChild(hhead);
            document.body.insertBefore(hhead, document.body.childNodes[0]);
            $("#nav_pop_menu").css("top", "45px");
        } else {
            var tBar = {
                leftBar: a,
                titleBar: b,
                rightBar: c,
            };
            document.addEventListener("WebViewJavascriptBridgeReady", function () {
                XIBLS.bindBar(tBar, null, null);
            });
        }
    };
    connectWebView();

    $(function () {
        XIBLS.Bar.bind();
    });

    XIBLS.Finger = {};
    XIBLS.Finger.support = function () {
        if(XIBLS.ios){
		  return XIBLS.mbank && XIBLS.ios && (parseFloat(XIBLS.clientVersion) >= 1.0);
        }
        return XIBLS.mbank && XIBLS.android && (parseFloat(XIBLS.clientVersion) >= 1.0);
    };

    XIBLS.Finger.fgInfo = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'FGPlugin', 'fgInfo', options);
    };

    XIBLS.Finger.fgLoginOpen = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'FGPlugin', 'fgLoginOpen', options);
    };

    XIBLS.Finger.fgLoginClose = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'FGPlugin', 'fgLoginClose', options);
    };

    XIBLS.Finger.fgLoginVerify = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'FGPlugin', 'fgLoginVerify', options);
    };


    XIBLS.Live = {};
    XIBLS.Live.support = function () {
        return XIBLS.mbank && (parseFloat(XIBLS.clientVersion) >= 1.1);

    };
    XIBLS.Live.faceInfo = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'Live', 'faceInfo', options);
     /***
      *  onSuccess(data){
      *      data:{"deviceFace":"设备是否支持人脸识别", "userFace":"用户是否开通人脸登录"},
      *  }
      **/
    };

    XIBLS.Live.faceGet = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'Live', 'faceGet', options);
     /***
      *  onSuccess(data){
      *      var face = data.face|| '';//最佳人脸
      *  }
      **/
    };

    XIBLS.Live.faceLoginOpen = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'Live', 'faceLoginOpen', options);
    };

    XIBLS.Live.faceLoginClose = function (options, onSuccess, onFail) {
        options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'Live', 'faceLoginClose', options);
    };



    XIBLS.Crypt = {};
    XIBLS.Crypt.support = function () {
        return XIBLS.mbank && (parseFloat(XIBLS.clientVersion) >= 1.2);
    };

    XIBLS.Sign = {};
    XIBLS.Sign.support = function () {
    	return XIBLS.mbank && (parseFloat(XIBLS.clientVersion) >= 1.3);
    };

    /***
     * options
     * {	"name":"张三","idCode":"证件类型0-身份证 1-护照 2-军人身份证,...","idNumber":"证件号码","phoneNumber":"手机号",
     * 		"hashAlg":"SM3" //icop会返回，必须送, 如果为空或者为null，根据caca接口协议则业务数据为原始明文
     * 		"signData":{"key1":"hash1","key1":"hash1", ...} //待签名加签的数据
     * } //接口参数
     *  onSuccess(data) {
     *      data:{"key1":"signedHash1", "key2":"signedHash2", ..., "certSN":"2000000444"}
     *  }
     **/
    XIBLS.Sign.signMessageWithCert = function (options, onSuccess, onFail) {
    	options = options || {};
        WebViewJavascriptBridge.callService(onSuccess, onFail, 'Sign', 'signMessageWithCert', options);
    };

    /***
     * 获取客户端公钥信息，根据certType类型取对应的公钥
     * options
     * {
     * 	   "name":"张三","idCode":"证件类型0-身份证 1-护照 2-军人身份证,...","idNumber":"证件号码","phoneNumber":"手机号",
     *     "certType":"hke"//后续扩展需要，当前现固定传hke
     * } //接口参数
     *  onSuccess(data) {
     *      data:{"certContent":"返回公钥信息"}
     *  }
     **/
    XIBLS.Sign.getCertContent = function (options, onSuccess, onFail) {
    	options = options || {};
    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'Sign', 'getCertContent', options);
    };

    XIBLS.Download = {};
    XIBLS.Download.support = function () {
    	return XIBLS.mbank && (parseFloat(XIBLS.clientVersion) >= 1.3);
    };

    /**
     * 从服务端资源下载
     * options
     * {
     * 	    "url":"service/down/customer/source"，必选项
     * 		"sourceType":"ghzd",//资源类型，国行E贷文件，必选项
     * 		"fileName":"ZX"//文件名称，必选项
     * 		"fileType":"pdf"//文件名称，必选项
     *
     *      "openFile":"1"//可选项：1下载完成后打开文件，默认为0不打开
     *      "otherParam":""//可选项：预留，允许为空，为null
     * }
     *
     * onSuccess(data) {
     *     data.msg //文件下载成功
     *     data.filePath //返回客户端本地文件保存的路径
     * }
     */
    XIBLS.Download.file = function (options, onSuccess, onFail) {
    	options = options || {};
    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'Download', 'downloadFile', options);
    };

    /**
     * 通知客户端重置已下载的资源
     * options
     * {
     * 		"sourceType":"ghzd",//资源类型，国行E贷文件
     * }
     */
    XIBLS.Download.reset = function (options, onSuccess, onFail) {
    	options = options || {};
    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'Download', 'resetDir', options);
    };


    XIBLS.SocialShare = {};
    /***
    * options:
    * { title: "标题",
    *     desc: "简短描述",
    *     thumbnail: "缩略图URI",
    *     url: "分享WEB网址"
    * } //接口参数
    * }
    *
    */
    XIBLS.SocialShare.shareAll = function (onSuccess, onFail, options) {
	    options = options || {};
	    if(XIBLS.mbank && (parseFloat(XIBLS.clientVersion) >= 1.3)){
	    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'SocialShare', 'shareAll', options);
	    }
	};



	XIBLS.JTRecorder = {};
	XIBLS.JTRecorder.support = function () {
    	return XIBLS.mbank && (parseFloat(XIBLS.clientVersion) >= 1.4);
    };

    XIBLS.JTRecorder.voiceGet = function (onSuccess, onFail, options) {
     /***
    * options:
    * { randomStr: '111111,222222,33333']}
    * onSuccess{voice:['voice1','voice2']}
    * onFail{msg:'msg'}
    */
	    options = options || {};
	    if(XIBLS.JTRecorder.support()){
	    	WebViewJavascriptBridge.callService(onSuccess, onFail, 'JTRecorder', 'voiceGet', options);
	   }
	};

	function pushHistory() {
	    var state = {
	        title: "",
	        url: window.location.href//"__SELF__"
	    };
	    window.history.pushState(state, state.title, state.url);
	}

  XIBLS.callService  = function (param) {
    var ret;
    if (XIBLS.android) {
      ret = XMF.callService(JSON.stringify(param));
    } else {
      ret = XMF.callService(param);
    }
    if (typeof ret === 'string') {
      return JSON.parse(ret);
    }
    return ret;
  };

  /**
   * 生物登錄設置
   */
  XIBLS.BioLogin = {}
  XIBLS.BioLogin.loginClose = function (bioType, onSuccess, onFail) {
    bioType = bioType || '';
    var options = {
      loginType: bioType,
      onOffFlag: 0
    };
    WebViewJavascriptBridge.callService(onSuccess, onFail, 'BioLogin', 'setLogin', options);
  };

  XIBLS.BioLogin.loginOpen = function (bioType, onSuccess, onFail) {
    bioType = bioType || '';
    var options = {
      loginType: bioType,
      onOffFlag: 1
    };
    WebViewJavascriptBridge.callService(onSuccess, onFail, 'BioLogin', 'setLogin', options);
  };

})();
